openerp.eiru_utilidad_golden = function (instance,local) {
    "use strict";

    local.ReportInvoiceUtilityWidget = instance.Widget.extend({
        template: 'ReportInvoiceUtility',
        invoices: [],
        invoiceLines: [],
        productProduct:[],
        content: [],
        Currency:[],
        rowsData :[],
        rowOrigin:[],
        accountJournal:[],
        resCompany:[],

        events:{
            'click #toolbar > button' : 'clickOnAction',
            // 'change #current-journal': 'fectSearch',
            'change #current-company': 'fectSearch',
            'click #X' : 'fectSearch',
            'click #A' : 'fectSearch',
            'click #B' : 'fectSearch',
            'click #C' : 'fectSearch',
            'click #D' : 'fectSearch',
            'click #Z' : 'fectSearch',
            'change #from' : 'fectSearch',
            'change #to': 'fectSearch',

            'click-row.bs.table #table' : 'ckickAnalysisDetail',
        },
        init : function(parent){
          this._super(parent);
        },
        start: function () {
            var self = this;
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.rowsData});
            this.fecthFecha();
            this.submitForm();
        },
        // Analisis Detallado
        ckickAnalysisDetail: function(e, row, $element, field){

            if (field == 'name'){
                this.do_action({
                    name : "Variantes de Producto",
                    type : 'ir.actions.act_window',
                    res_model : "product.product",
                    views : [[false,'form']],
                    target : 'new',
                    domain : [['id','=', row.id_product]],
                    context : {},
                    flags : {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id : row.id_product,
                });
            }
            if (field == 'number'){
                this.do_action({
                    name : "Factura de Cliente",
                    type : 'ir.actions.act_window',
                    res_model : "account.invoice",
                    views : [[false,'form']],
                    target : 'new',
                    domain : [['type', '=', 'out_invoice'],['id','=', row.id]],
                    context : {},
                    flags : {'form': {'action_buttons': false, 'options': {'mode': 'view'}}},
                    res_id : row.id,
                });
            }
            e.stopImmediatePropagation();
        },

        // Cansultar
        submitForm: function () {
            var self = this;
            this.fetchCurency().then(function(Currency) {
                self.Currency = Currency;
                return Currency;
            }).then(function (Currency) {
                return self.fetchJournal();
            }).then(function (journal) {
                self.accountJournal =journal;
                self.$el.find('#current-journal').append('<option value="9999999">TODAS LAS SUC.</option>');
                _.each(journal, function (item) {
                  self.$el.find('#current-journal').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.fetchInvoiceV2();
            }).then(function (invoices){
                self.invoices = invoices;
                return self.fetchInvoiceLine(invoices);
            }).then(function (invoiceLines) {
                self.invoiceLines = invoiceLines;
                return self.fecthProduct(invoiceLines);
            }).then(function(productProduct){
                self.productProduct = productProduct;
                return self.fecthComanyCurrency();
            }).then(function(resCompany){
                self.resCompany = resCompany;
                self.$el.find('#current-company').append('<option value="9999999">Todas las companias.</option>');
                _.each(resCompany,function(item){
                    self.$el.find('#current-company').append('<option value="' + item.id + '">' + item.name + '</option>');
                });
                return self.invoice_Currency();
            });
        },
        // company_curency
        fecthComanyCurrency: function(){
            var self = this;
            var defer = $.Deferred();
            var currency = new instance.web.Model('res.company');
            var field=['id', 'name', 'currency_id'];
            // var domain=[['id','=',1]];
            currency.query(field).filter().all().then(function(results){
                defer.resolve(results);
            });
            return defer;
        },
        // Fecha
        fecthFecha: function() {
            var to;
            var dateFormat1 = "mm/dd/yy",
              from = $( "#from" )
                .datepicker({
                  dateFormat: "dd/mm/yy",
                  changeMonth: true,
                  numberOfMonths: 1,
                })
                .on( "change", function() {
                  to.datepicker( "option", "minDate", getDate(this), "dd/mm/yyyy");
                });
              to = $( "#to" ).datepicker({
                dateFormat: "dd/mm/yy",
                defaultDate: "+7d",
                changeMonth: true,
                numberOfMonths: 1,
              })
              .on( "change", function() {
                from.datepicker( "option", "maxDate", getDate(this));
              });

            function getDate( element ) {
              var fechaSel =element.value.split('/');
              var date;
              try {
                date = $.datepicker.parseDate( dateFormat1, (fechaSel[1]+"/"+fechaSel[0]+"/"+fechaSel[2]));
              } catch( error ) {
               date = null;
              }
              return date;
            }
          },
        // Buscar Diario
        fetchJournal: function () {
            var self = this;
            var defer = $.Deferred();
            var Journal = new instance.web.Model('account.journal');
            Journal.query(['id', 'name']).filter([['type', '=', 'sale'], ['active', '=', true]]).all().then(function (results) {
                defer.resolve(results);
            });
              return defer;
        },
        // Buscar Cambio de Monedas USD,PYG,ARG,BRL
        fetchCurency: function () {
            var defer = $.Deferred();
            var currency_Rate = new instance.web.Model('res.currency.rate');
            var fields = ['id', 'name', 'currency_id', 'rate', 'create_date'];
            var domain = [['currency_id', 'in', [166 , 20, 7, 3]]];
            currency_Rate.query(fields).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
          },
        // Invoice (FACTURAS)
        fetchInvoiceV2: function () {
            var defer = $.Deferred();

            // var journal_ids = _.flatten(_.map(this.accountJournal, function (item) {
            //     return item.id;
            // }));
            // if (journal_ids){
            //     filter=filter.concat(",['journal_id', 'in',["+journal_ids+"]]");
            // }
            // filter=filter.concat("]");
            var hoy = moment().format('YYYY-MM-DD');
            var field =['id', 'type', 'number', 'origin', 'state', 'journal_id', 'currency_id', 'invoice_line','company_id', 'date_invoice'];
            var domain ="[['state', 'in',['open','paid']],['type', '=', 'out_invoice']]";
            var Invoice = new instance.web.Model('account.invoice');
            Invoice.query(field).filter(domain).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },
        // Invoice line (Linea de Factura)
        fetchInvoiceLine: function (invoices) {
            var defer = $.Deferred();
            var linesIds = _.flatten(_.map(invoices, function (item) {
                return item.invoice_line;
            }));
            var InvoiceLine = new instance.web.Model('account.invoice.line');
            InvoiceLine.query(['id', 'quantity', 'price_unit', 'discount', 'name', 'product_id', 'origin','invoice_id']).filter([['id', 'in', linesIds]]).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },
        // Product Product
        fecthProduct: function(invoiceLines){
            var defer = $.Deferred();
            var porductIDS = _.flatten(_.map(invoiceLines, function (item) {
                return item.product_id[0];
            }));
            var ProductProdcut =  new instance.web.Model('product.product');
            var fields = ['id', 'default_code', 'name_template','ean13', 'standard_price','type'];
            ProductProdcut.query(fields).filter([['id', 'in', porductIDS]]).all().then(function (results) {
                defer.resolve(results)
            });
            return defer;
        },
        // Obtener Monedas de la Factura
        getCutrrency: function (id){
            return _.find(this.Currency,function (curr) {
                return _.contains(curr.currency_id,id);
            });
        },
        // Actualizar cambio de las moneda de Factura
        invoice_Currency: function(){
            for (var i = 0; i < this.invoices.length; i++) {
                var currency_new;
                var item = this.invoices[i];
                var id = item.currency_id[0];
                currency_new = this.getCutrrency(id);
                if (!currency_new){
                    currency_new={};
                    currency_new.rate=1;
                }
                this.invoices[i].rate=(currency_new.rate);
            }
            return this.fectUtility();
        },
        // Obtener la Detalles de la Factura
        getInvoice: function (id_line){
            return _.find(this.invoices, function (inv) {
                return _.contains(inv.invoice_line, id_line);
            });
        },

        // Obtener las lineas de las Facturas
        getProduct: function(pro_id){
            return _.find(this.productProduct, function(prod){
                return _.contains(pro_id, prod.id);
            });
        },
        // unir los objetos
        fectUtility: function(){
            var self = this;
            var data=[];
            var item;
            var invoice;
            var producto;
            var invoiceLines = self.invoiceLines;

            for (var i = 0; i < invoiceLines.length; i++) {
                item = this.invoiceLines[i];
                invoice = this.getInvoice(item.id);
                producto =this.getProduct(item.product_id);
                if (!producto){
                    producto={};
                    producto.standard_price=0;
                }
                // if (producto.type =="product"){
                    data.push({
                            id : invoice.id,
                            number : (invoice.number),
                            id_product : producto.id,
                            name : (item.name),
                            quantity : accounting.formatNumber((item.quantity),0, ".", ","),
                            price_unity : accounting.formatNumber((item.price_unit / invoice.rate),2, ".", ","),
                            standar_price : accounting.formatNumber((producto.standard_price),2, ".", ","),
                            price_tot : accounting.formatNumber((item.quantity * (item.price_unit / invoice.rate)),2, ".", ","),
                            standar_tot : accounting.formatNumber((item.quantity * producto.standard_price),2, ".", ","),
                            utility : accounting.formatNumber(((item.quantity * (item.price_unit / invoice.rate)) - (item.quantity * producto.standard_price)),2, ".", ","),
                            journal_id :(invoice.journal_id[0]),
                            company_id :(invoice.company_id[0]),
                            company_name :(invoice.company_id[1]),
                            journal_name :(invoice.journal_id[1]),
                            date_invoice: moment(invoice.date_invoice).format("DD/MM/YYYY"),
                            date: invoice.date_invoice
                    });
          }
          self.rowsData = data;
          this.loadTable(data);
        },
        // Buscar
        fectSearch: function(){
            var self = this;
            var today = moment().format('YYYY-MM-DD');
            var yesterday = moment().add(-1, 'days').format('YYYY-MM-DD');
            var month = moment().format('YYYY-MM');
            var last_month = moment().add(-1, 'months').format('YYYY-MM');
            var desde = self.$el.find('#from').val();
            var hasta = self.$el.find('#to').val();
            var company = self.$el.find('#current-company').val().split('-');

            // var suc = self.$el.find('#current-journal').val();
            var content = self.rowsData;

            if ($('#A').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM-DD') == today;
                });
            }

            if ($('#B').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM-DD') == yesterday;
                });
            }
            if ($('#C').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM') == month;
                });
            }
            if ($('#D').is(":checked")){
                content = _.filter(content, function (inv){
                    return moment(inv.date).format('YYYY-MM') == last_month;
                });
            }
            // if (suc != 9999999){
            //     self.rowsData=_.filter(self.rowsData, function (inv){
            //         return inv.journal_id == suc;
            //     });
            // }
            if ($('#Z').is(":checked")){
                $('#datepicker').css('display','block');
                if (desde.length > 0){
                    var date= desde.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date >= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
                if (hasta.length > 0){
                    var date= hasta.split('/');
                    content = _.filter(content, function (inv){
                        return inv.date <= (date[2]+"-"+date[1]+"-"+date[0]);
                    });
                }
            }else{
                $('#datepicker').css('display','none');
            }
            if (company != 9999999){
                content = _.filter(content, function (inv){
                    return inv.company_id == company;
                });
            }

            self.loadTable(content);
        },
        // cargara la tabla
        loadTable:function(rowsTable){
            var self = this;
            // self.rowsData = rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load',rowsTable);
        },
        // imprimir PDF
        clickOnAction: function (e) {
            var action = this.$el.find(e.target).val();
            var self = this;
            var getColumns=[];
            var rows=[];
            var table = this.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){ return val.field});
                _.each(this.rowsData,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
                // Obtener los nombre de la Cabezera
                _.each(_.map(data2,function(val){
                    return val}), function(item){
                    getColumns.push([{
                                    title: item.title,
                                    dataKey: item.field
                                }]);
                });
                // Llamar al pdf
                this.drawPDF(_.flatten(getColumns),rows)
            }
            if (action === 'chart'){
                var suc =this.$el.find('#current-journal').val();
                if (suc == 9999999){
                    self.fectCharFilter();
                }else{
                    $("#dialog" ).dialog({
                        autoOpen: true,
                        resizable: false,
                        modal: true,
                        title: 'Atención',
                        open: function() {
                            $(this).html('Para Generar el Gráfico debes Seleccionar todas las Sucursales');
                        },
                        show: {
                            effect: "shake",
                            duration: 300
                        },
                        hide: {
                            effect: "fade",
                            duration: 300
                        },
                        buttons: {
                            Aceptar: function() {
                                $(this).dialog('close');
                            }
                        }
                    });
                }
            }
        },
        // Generar pdfDoc
        drawPDF: function (getColumns,rows) {
            var self = this;
            var rowsPdf=[];
            var sucusal = this.sucDescrip = this.$el.find('#current-journal option:selected').text();
            var desde =(this.$el.find('#from').val());
            var hasta =(this.$el.find('#to').val());
            var totalPagesExp = "{total_pages_count_string}";
            var pdfDoc = new jsPDF();

            // rows=this.rowsData;
            var quantity=_.reduce(_.map(rows,function(item){
                var valor=0;
                if (item.quantity){valor = parseFloat(((item.quantity.replace(".","")).replace(",",".")))}return valor}), function(memo, num){ return memo + num; },0);
            var precio_unit=_.reduce(_.map(rows,function(item){
                var valor =0;
                if (item.price_unity){valor=parseFloat(((item.price_unity.replace(".","")).replace(",",".")))} return valor}), function(memo, num){ return memo + num; },0);
            var precio_cost=_.reduce(_.map(rows,function(item){
                var valor=0;
                if(item.standar_price){valor=parseFloat(((item.standar_price.replace(".","")).replace(",",".")))} return valor}), function(memo, num){ return memo + num;},0);
            var tot_unit=_.reduce(_.map(rows,function(item){
                var valor=0;
                if (item.price_tot){valor=parseFloat(((item.price_tot.replace(".","")).replace(",",".")))}return valor}), function(memo, num){ return memo + num; },0);
            var tol_cost=_.reduce(_.map(rows,function(item){
                var valor=0;
                if (item.standar_tot){valor=parseFloat(((item.standar_tot.replace(".","")).replace(",",".")))} return valor }), function(memo, num){ return memo + num; },0);
            var utility=_.reduce(_.map(rows,function(item){
                var valor=0;
                if (item.utility){valor=parseFloat(((item.utility.replace(".","")).replace(",",".")))}return valor }), function(memo, num){ return memo + num; },0);

            rowsPdf=rows;

            var company = _.map(self.resCompany, function (map) {
                return map.currency_id[1];
            });
            rowsPdf.push({
                        number : "  ",
                        name : "TOTAL "+company,
                        quantity: accounting.formatNumber(quantity,0, ".", ","),
                        price_unity : accounting.formatNumber(precio_unit,2, ".", ","),
                        standar_price : accounting.formatNumber(precio_cost,2, ".", ","),
                        price_tot : accounting.formatNumber(tot_unit,2, ".", ","),
                        standar_tot : accounting.formatNumber(tol_cost,2, ".", ","),
                        utility : accounting.formatNumber(utility,2, ".", ",")
                    });

            rowsPdf.unshift({
                        number : "  ",
                        name : "TOTAL "+company,
                        quantity: accounting.formatNumber(quantity,0, ".", ","),
                        price_unity : accounting.formatNumber(precio_unit,2, ".", ","),
                        standar_price : accounting.formatNumber(precio_cost,2, ".", ","),
                        price_tot : accounting.formatNumber(tot_unit,2, ".", ","),
                        standar_tot : accounting.formatNumber(tol_cost,2, ".", ","),
                        utility : accounting.formatNumber(utility,2, ".", ",")
                    });

            pdfDoc.autoTable(getColumns, rowsPdf, {
                styles: { overflow: 'linebreak', fontSize: 8, columnWidth: 'wrap'},
                columnStyles: {
                              number: {fontStyle: 'bold'},
                              name :{columnWidth: '10px'},
                              quantity :{halign:'right' },
                              price_unity : {halign:'right' },
                              standar_price : {halign:'right' },
                              price_tot : {halign:'right' },
                              standar_tot : {halign:'right' },
                              utility : {halign:'right'},
                          },
                margin: { top: 16, horizontal: 7},
                addPageContent: function (data) {
                    pdfDoc.setFontSize(12);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text('Utilidad de facturas detalladas por '+ sucusal, data.settings.margin.left, 10);

                    if(desde.length > 0 || hasta.length > 0){
                      var fecha='';
                      if(desde){
                        fecha=fecha.concat(' Desde '+desde);
                      }
                      if (hasta){
                        fecha=fecha.concat(' Hasta '+hasta);
                      }
                        pdfDoc.setFontSize(10);
                        pdfDoc.setFontStyle('bold');
                        pdfDoc.setTextColor(40)
                        pdfDoc.text(fecha, data.settings.margin.left,14);
                    }
                    // FOOTER
                    var str = "Pagina  " + data.pageCount;
                    // Total page number plugin only available in jspdf v1.0+
                    if (typeof pdfDoc.putTotalPages === 'function') {
                        str = str + " de " + totalPagesExp;
                    }
                    pdfDoc.setFontSize(9);
                    pdfDoc.setFontStyle('bold');
                    pdfDoc.setTextColor(40);
                    pdfDoc.text(str, data.settings.margin.left, pdfDoc.internal.pageSize.height - 5);
                }
            });

            if (typeof pdfDoc.putTotalPages === 'function') {
                pdfDoc.putTotalPages(totalPagesExp);
            }
            pdfDoc.save('Utilidad de facturas detalladas.pdf')
        },

    });
    // Resumen de Ingresos
    instance.web.client_actions.add('eiru_utilidad_golden.action_report', 'instance.eiru_utilidad_golden.ReportInvoiceUtilityWidget');

}
